open A1

(***********)
(* Testing *)
(***********)

(* Augment the testing infrastructure below as you see fit.
 * The current implmentation is not very complete. *)


(* This function takes a boolean condition and a string error message,
   and if the condition is false it prints the error message. It returns
   the value of the condition.
*)
let run_test (cond: bool ) (msg : string) : bool =
  if not cond then Printf.printf "%s\n" msg ;
  flush stdout ;
  cond

(*
Pretty printing for testing
 *)

let print_header ( prob: string) : unit =
  let row = "----------------------------------------\n" in
  Printf.printf "\n%s%s\n%s" row prob row ;
  flush stdout

(* Testing Problem 3 *)
(* Take note that prob 3a-3c won't compile if not corrected, but they are
 * checked anyway for correctness*)
let _ = print_header ( "Problem 3" )

let _ = run_test (prob3a = true) "3a should be true"
let _ = run_test (prob3b = 55) "3b should be 55"
let _ = run_test (prob3c = 55) "3c should be 55"

let _ = print_string "Tests complete\n"


(* Testing Problem 5 *)

let test_BadDivisors (cond: bool) (msg : string) =
  run_test (
  try cond with
  | BadDivisors (n,m) -> false
  | _ -> false) msg

let _ = print_header ( "Problem 5" )
let _ = run_test ( few_divisors 17 3 ) "Incorrect answer for arguments: 17 3"
let _ = test_BadDivisors (few_divisors 4 4) "Incorrect answer for arguments: 4 4"

let _ = print_string "Tests complete\n"


(* Testing Problem 6a *)

(* compare floats down to the point of floating point figments *)
let cmp_float (f1:float) (f2:float) : bool =
  let d = f1 -. f2 in
  abs_float d < 0.0000000001

let _ = print_header ( "Problem 6a" )

let result = 
  try sin_pi 0 with
  | BadPi n -> (print_string "sin_pi 0 threw BadPi -- "; nan)

let _ = 
  run_test (cmp_float result 3.)
           ("Incorrect answer for argument 0: "^(string_of_float result))

let _ =
  begin
    let result = sin_pi 1 in
    run_test 
      (cmp_float result 3.14112000805986735)
      ("Incorrect answer for argument 1: "^(string_of_float result))
  end

let _ = print_string "Tests complete\n"
